<template>
  <section>
    <b-loading :active="isLoading"></b-loading>
    <div class="card">
      <nav class="navbar has-background-white-bis">
        <div class="navbar-brand">
          <span class="navbar-item title is-2">Editar Jugador</span>
        </div>
      </nav>
      <div class="section">
        <form @submit.prevent="validate">
          <div class="columns is-multiline">
            <div class="column is-5"></div>
            <div class="column is-4">
              <div class="card-image">
                <!-- Show preview of uploaded image -->
                <img
                  v-if="!getImage"
                  :src="'data:image/jpg;base64, ' + model.image"
                  alt=""
                />
                <img
                  :src="getImage"
                  v-if="getImage"
                  alt="Uploaded Image"
                  style="max-width: 100%; height: auto"
                />
                <!-- Upload button -->
                <b-upload
                  accept="image/*"
                  v-model="model.file"
                  @input="changeImage"
                >
                  <a class="card-content-m button is-primary">
                    <b-icon icon="upload"></b-icon>
                    <span>Subir Imagen</span>
                  </a>
                </b-upload>
              </div>
            </div>
            <div class="column is-6">
              <b-field
                label="Titulo*"
                :type="{ 'is-danger': errors.has('title') }"
                :message="errors.first('title')"
              >
                <b-input
                  size="is-medium"
                  v-model="model.title"
                  name="title"
                  data-vv-as="Nombre"
                  v-validate="'required'"
                  placeholder="Requerido"
                />
              </b-field>
            </div>
            <div class="column is-6">
              <b-field
                label="Tipo*"
                :type="{ 'is-danger': errors.has('eventType') }"
                :message="errors.first('eventType')"
              >
                <b-select
                  placeholder="Seleccione un tipo"
                  size="is-medium"
                  v-model="model.type"
                  expanded
                >
                  <option
                    v-for="item in types"
                    :key="item.id"
                    :value="item.value"
                  >
                    {{ item.label }}
                  </option>
                </b-select>
              </b-field>
            </div>
            <div class="column is-12">
              <b-field
                label="Descripción*"
                :type="{ 'is-danger': errors.has('description') }"
                :message="errors.first('description')"
              >
                <b-input
                  type="textarea"
                  name="description"
                  data-vv-as="Descripción"
                  v-validate="'required'"
                  placeholder="Requerido"
                  v-model="model.description"
                ></b-input>
              </b-field>
            </div>
          </div>
          <nav class="level">
            <!-- Left side -->
            <div class="level-left">
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-danger"
                  @click="cancel"
                  icon-right="cancel"
                  >Cancelar</b-button
                >
              </p>
            </div>

            <!-- Right side -->
            <div class="level-right">
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-primary"
                  native-type="submit"
                  icon-right="content-save"
                  >Guardar</b-button
                >
              </p>
            </div>
          </nav>
        </form>
      </div>
    </div>
  </section>
</template>
<script lang="ts">
import { Component, Vue, Watch } from "vue-property-decorator";
import BaseVue from "../../core/BaseVue";
import { Utils } from "@/core/Utils";
import EventModel from "@/models/event.model";
import EventService from "@/services/eventservice";
import { EventType } from "@/enums/eventType";

@Component
export default class EventEdit extends BaseVue {
  model: EventModel;
  eventService: EventService = new EventService();
  eventId: number = 0;
  isLoading: boolean = false;
  imageResult: any = null;
  constructor() {
    super();
    this.model = new EventModel();
    this.eventId = Number(this.$route.params.id);
  }

  types: any = [
    {
      label: "Noticia",
      value: EventType.News,
    },
    {
      label: "Evento",
      value: EventType.Event,
    },
  ];
  created() {
    this.getEventModelById();
  }

  get getImage() {
    if (this.imageResult) return this.imageResult;
    return false;
  }

  changeImage() {
    debugger
    var self = this;
    self.model.image = [];
    var reader = new FileReader();
    reader.readAsArrayBuffer(this.model.file);
    this.imageResult = URL.createObjectURL(this.model.file);
    reader.onloadend = function (evt: any) {
      if (evt.target.readyState == FileReader.DONE) {
        var arrayBuffer = evt.target.result,
          array = new Uint8Array(arrayBuffer);
        for (var i = 0; i < array.length; i++) {
          self.model.image.push(array[i]);
        }
      }
    };
  }

  getEventModelById() {
    this.isLoading = true;
    this.eventService
      .getEventById(this.eventId)
      .then((resp) => {
        Utils.mapToObject(resp.data, this.model);
      })
      .finally(() => {
        this.isLoading = false;
      });
  }

  public cancel() {
    this.$router.push(`${this.$router.currentRoute.path.split("/editar")[0]}`);
  }

  public async validate() {
    try {
      this.isLoading = true;
      var result = await this.$validator.validateAll();
      if (result) {
        await this.eventService
          .updateEvent(this.eventId, this.model)
          .then((resp) => {
            this.operationSuccess();
          })
          .finally(() => {
            this.isLoading = false;
            this.$router.push(
              `${this.$router.currentRoute.path.split("/editar")[0]}`
            );
          });
        return;
      }
      throw this.$validator.errors.items.map((e) => e.msg);
    } catch (errors) {
      this.isLoading = false;
      this.operationFailedErrors(errors as any);
    }
  }
}
</script>

<style>
.card-image {
  width: 300px;
  border-radius: 8px;
  box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
  overflow: hidden;
}

.card-image img {
  width: 100%;
  height: 100%; /* Ensure the image fills the container */
  object-fit: cover; /* Maintain aspect ratio and cover entire container */
  display: block;
}

.card-content-m {
  padding: 16px !important;
  display: flex !important;
  flex-direction: column !important;
  align-items: center !important;
  justify-content: center !important; /* Center vertically and horizontally */
  height: 100% !important; /* Ensure the content fills the card height */
  margin-top: 10px;
}
.upload {
  /* You can reset the display property to override Buefy's styles */
  display: flex !important;
  justify-content: center !important; /* Center the button horizontally */
  align-items: center !important; /* Center the button vertically */
}

.card-content-m button {
  padding: 8px 16px;
  background-color: #007bff;
  color: #fff;
  border: none;
  border-radius: 4px;
  cursor: pointer;
  transition: background-color 0.3s ease;
}

.card-content-m button:hover {
  background-color: #0056b3;
}
</style>
